#!/bin/bash

SOURCE_DIR=$(dirname "$0")
SYMBOL_FILE="$SOURCE_DIR/symbols"
SYMBOL_HEADER="$SOURCE_DIR/src/symbols.h"
KERNEL_VERSION=${1:-$(uname -r)}

echo "Generating symbols header for kernel $KERNEL_VERSION"

rm -f $SYMBOL_HEADER

cat << EOF >> $SYMBOL_HEADER
/* Autogenerated by $(basename $0) */

#ifndef _VOLSNAP_SYMBOLS_H
#define _VOLSNAP_SYMBOLS_H

EOF

while read SYMBOL_NAME; do
    [[ -z "$SYMBOL_NAME" ]] && continue

    MACRO_NAME="${SYMBOL_NAME^^}_PTR"
    SYMBOL_ADDR=$(grep -w $SYMBOL_NAME /boot/System.map-$KERNEL_VERSION | awk '{print $1}')
    if [[ -z $SYMBOL_ADDR ]]; then
        SYMBOL_ADDR="0"
    fi

    echo "#define $MACRO_NAME ((void *)0x$SYMBOL_ADDR)" >> $SYMBOL_HEADER

done < $SYMBOL_FILE

echo -e "\n#endif /* _VOLSNAP_SYMBOLS_H */" >> $SYMBOL_HEADER
